apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  name: node-s2i-build
  namespace: ci
spec:
  params:
  - default: .
    description: The location of the path to run s2i from
    name: contextdir
    type: string
  - default: https://registry.npmjs.org
    description: NPMJS Repository Endpoint
    name: npmmirror
    type: string
  - default: nodejs:master
    description: S2i Base Image
    name: fromimage
    type: string
  - default: "true"
    description: Verify the TLS on the registry endpoint (for push/pull to a non-TLS registry)
    name: tlsverify
    type: string
  resources:
    inputs:
    - name: source
      targetPath: /
      type: git
    outputs:
    - name: image
      type: image
  steps:
  - args:
    - -c
    - |
      . /usr/local/bin/set_runtime
      echo NODE_ENV=production >>/env-params/env-file
      echo NO_AUDIT=yep >>/env-params/env-file
      if test "$(inputs.params.npmmirror)"; then
          echo NPM_MIRROR=$(inputs.params.npmmirror) >>/env-params/env-file
      fi
    command:
    - /bin/sh
    image: registry.registry.svc.cluster.local:5000/ci/jenkins-agent-node-sonar:master
    name: generate-environ
    resources: {}
    securityContext:
      runAsUser: 1000
    volumeMounts:
    - mountPath: /env-params
      name: envparams
  - command:
    - s2i
    - build
    - $(inputs.params.contextdir)
    - registry.registry.svc.cluster.local:5000/ci/$(inputs.params.fromimage)
    - --image-scripts-url
    - image:///usr/libexec/s2i
    - --as-dockerfile
    - /gen-source/Dockerfile.gen
    - --environment-file
    - /env-params/env-file
    image: quay.io/openshift-pipeline/s2i
    name: generate-image-build-assets
    resources: {}
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /gen-source
      name: gen-source
    - mountPath: /env-params
      name: envparams
  - command:
    - buildah
    - bud
    - --squash
    - --tls-verify=$(inputs.params.tlsverify)
    - --layers
    - -f
    - /gen-source/Dockerfile.gen
    - -t
    - $(outputs.resources.image.url)
    - .
    image: quay.io/buildah/stable
    name: build
    resources: {}
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /dev/fuse
      name: devfuse
    - mountPath: /var/lib/containers
      name: varlibcontainers
    - mountPath: /gen-source
      name: gen-source
    workingDir: /gen-source
  - command:
    - buildah
    - push
    - --tls-verify=$(inputs.params.tlsverify)
    - $(outputs.resources.image.url)
    - docker://$(outputs.resources.image.url)
    image: quay.io/buildah/stable
    name: push-image
    resources: {}
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /dev/fuse
      name: devfuse
    - mountPath: /var/lib/containers
      name: varlibcontainers
  volumes:
  - hostPath:
      path: /dev/fuse
    name: devfuse
  - emptyDir: {}
    name: envparams
  - emptyDir: {}
    name: gen-source
  - emptyDir: {}
    name: varlibcontainers
